[LeetCode] Dungeon Game

简介: An interesting problem. The code is also short and clear. The basic idea is to use a 2d array dp[i][j] to denote the minimum hp that is required before entering dungeon[i][j].

An interesting problem. The code is also short and clear.

The basic idea is to use a 2d array dp[i][j] to denote the minimum hp that is required before entering dungeon[i][j]. Since the knight needs to be alive after entering the bottom-right cell of the dungeon, we will update dp from bottom-right to top-left. The updating formula is also simple:

dp[i][j] = max(1, min(dp[i][j + 1], dp[i + 1][j]) - dungeon[i][j]).

Taking the maximum with 1 guarantees that the hp of the knight never drops to or below 0. Since the knight only moves in two directions: rightwards or downwards, each cell (dp[i][j]) is only related to its right (d[i][j + 1]) and down (dp[i + 1][j]) neighbors.

The following code barely translates the above idea, while adding dummy rows and columns for initializations.

 1 class Solution {
 2 public:
 3     int calculateMinimumHP(vector<vector<int>>& dungeon) {
 4         int m = dungeon.size(), n = dungeon[0].size();
 5         vector<vector<int>> dp(m + 1, vector<int>(n + 1, INT_MAX));
 6         dp[m][n - 1] = dp[m - 1][n] = 1; // initialization
 7         for (int i = m - 1; i >= 0; i--)
 8             for (int j = n - 1; j >= 0; j--)
 9                 dp[i][j] = max(min(dp[i][j + 1], dp[i + 1][j]) -dungeon[i][j], 1);
10         return dp[0][0];
11     }
12 };

Of course, the 2d array can be simplified to a 1d array if we've been clear of how dp is updated (in the above code, dp is updated row by row from the bottom one to the top one and in each row it is updated from right to left). The 1d version is as follows.

 1 class Solution {
 2 public:
 3     int calculateMinimumHP(vector<vector<int>>& dungeon) {
 4         int m = dungeon.size(), n = dungeon[0].size();
 5         vector<int> dp(n + 1, INT_MAX); dp[n - 1] = 1; // initialization
 6         for (int i = m - 1; i >= 0; i--)
 7             for (int j = n - 1; j >= 0; j--)
 8                 dp[j] = max(min(dp[j], dp[j + 1]) - dungeon[i][j], 1);
 9         return dp[0];
10     }
11 };

Well, if you get confused, try to run the 2d code on the example in the problem statement and record the values of dp near the corresponding values of dungeon using different colors, as the following picture. After that, you will be clear, even of the 1d code :-)

目录
相关文章
LeetCode 390. Elimination Game
给定一个从1 到 n 排序的整数列表。 首先,从左到右,从第一个数字开始,每隔一个数字进行删除,直到列表的末尾。 第二步,在剩下的数字中,从右到左,从倒数第一个数字开始,每隔一个数字进行删除,直到列表开头。 我们不断重复这两步,从左到右和从右到左交替进行,直到只剩下一个数字。 返回长度为 n 的列表中,最后剩下的数字。
101 0
LeetCode 390. Elimination Game
LeetCode 292. Nim Game
你和你的朋友,两个人一起玩 Nim游戏:桌子上有一堆石头,每次你们轮流拿掉 1 - 3 块石头。 拿掉最后一块石头的人就是获胜者。你作为先手。 你们是聪明人,每一步都是最优解。 编写一个函数,来判断你是否可以在给定石头数量的情况下赢得游戏。
74 0
LeetCode 292. Nim Game
|
存储 算法
LeetCode 289. Game of Life
如果活细胞周围八个位置的活细胞数少于两个,则该位置活细胞死亡; 如果活细胞周围八个位置有两个或三个活细胞,则该位置活细胞仍然存活; 如果活细胞周围八个位置有超过三个活细胞,则该位置活细胞死亡; 如果死细胞周围正好有三个活细胞,则该位置死细胞复活;
76 0
LeetCode 289. Game of Life
|
算法 索引
LeetCode 55. Jump Game
给定一个非负整数数组,您最初定位在数组的第一个索引处。 数组中的每个元素表示该位置的最大跳转长度。 确定您是否能够到达最后一个索引。
90 0
LeetCode 55. Jump Game
|
算法 索引
LeetCode 45. Jump Game II
给定一个非负整数数组,初始位置在索引为0的位置,数组中的每个元素表示该位置的能够跳转的最大部署。目标是以最小跳跃次数到达最后一个位置(索引)。
80 0
LeetCode 45. Jump Game II
LeetCode contest 200 5476. 找出数组游戏的赢家 Find the Winner of an Array Game
LeetCode contest 200 5476. 找出数组游戏的赢家 Find the Winner of an Array Game
|
决策智能
LeetCode之Nim Game
LeetCode之Nim Game
120 0
|
C++
LeetCode 289 Game of Life(生命游戏)(Array)
版权声明:转载请联系本人,感谢配合!本站地址:http://blog.csdn.net/nomasp https://blog.csdn.net/NoMasp/article/details/52122735 翻译 根据维基百科的文章介绍:“Game of Life,简称为Life,是一个被英国数学家John Conway在1970年提出的细胞自动分裂器。
1638 0
LeetCode - 45. Jump Game II
45. Jump Game II  Problem's Link  ---------------------------------------------------------------------------- Mean:  给定一个数组a,玩家的初始位置在idx=0,玩家需要到达的位置是idx=a.
938 0